// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MOJO_SHELL_RUNNER_HOST_CHILD_PROCESS_BASE_H_
#define MOJO_SHELL_RUNNER_HOST_CHILD_PROCESS_BASE_H_

#include "base/callback.h"
#include "mojo/shell/public/interfaces/shell_client.mojom.h"

namespace mojo {
namespace shell {

// Child processes call this to establish the connection to the shell and obtain
// the ShellClientRequest. Once the connection has been established |callback|
// is run. ChildProcessMain() returns once the the callback completes.
using RunCallback = base::Callback<void(mojom::ShellClientRequest)>;
void ChildProcessMain(const RunCallback& callback);

}  // namespace shell
}  // namespace mojo

#endif  // MOJO_SHELL_RUNNER_HOST_CHILD_PROCESS_BASE_H_
